// DigestMaker.java
// Digest Maker 1.0
// 2013.2.19 (TUE)
// 北の電話男 Kita no Denwa-otoko
// http://www.geocities.jp/kitano_denwaotoko/
//
// 参考：http://www.atmarkit.co.jp/fjava/javatips/117java021.html

import java.security.MessageDigest;  
import java.security.NoSuchAlgorithmException;

class Digest {
	static public byte[] makeMD5Bytes(String str) {
		try {
			MessageDigest md = MessageDigest.getInstance("MD5");
			md.update(str.getBytes("Shift_JIS"));
			return md.digest();
		} catch (java.security.NoSuchAlgorithmException e) { //起こり得ない例外
			return null;
		} catch (java.io.UnsupportedEncodingException e) { //起こり得ない例外
			return null;
		}
	}
	
	static public String makeMD5String(String str) {
		byte[] hash = makeMD5Bytes(str);
		int len = hash.length;
		StringBuffer strb = new StringBuffer(len*2);
		for (int i=0;i<len;i++) {
			int d = hash[i] & 0xff;
			if (d < 0x10) strb.append('0');
			strb.append(Integer.toHexString(d));
		}
		return strb.toString();
	}
	
	static public String bytesToB64Str(byte[] in) {
		StringBuffer strb = new StringBuffer();
		String tane = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
		int inLen = in.length;
		int srcLen = (inLen*8)/6 + (((inLen*8) % 6 == 0)?0:1);
		int resAmari = srcLen % 4;
		int i,j;
		int[] src = new int [srcLen];
		
		int src3Len = inLen/3, in3amari = inLen % 3;
		j = -1;
		for (i = 0; i < src3Len; i++) {
			src[++j] =  (in[i*3] & 252) >>> 2;
			src[++j] = ((in[i*3] &  3) << 4) | ((in[i*3+1] & 240) >>> 4);
			src[++j] = ((in[i*3+1] & 15) << 2) | ((in[i*3+2] & 192) >>> 6);
			src[++j] = (in[i*3+2] & 63);
		}
		
		if (in3amari == 1) {
			src[++j] = (in[i*3] & 252) >>> 2;
			src[++j] = (in[i*3] & 3) << 4;
		} else if (in3amari == 2) {
			src[++j] =  (in[i*3] & 252) >>> 2;
			src[++j] = ((in[i*3] &  3) << 4) | ((in[i*3+1] & 240) >>> 4);
			src[++j] = ((in[i*3+1] & 15) << 2);
		}
		
		for (i = 0; i<srcLen; i++) {
			strb.append(tane.charAt(src[i]));
		}
		for (i = 0; i < resAmari; i++) { //4文字に足りていればスルー
			strb.append('=');
		}
		return strb.toString();
	}
}